## ros-foxy-system-metrics-collector 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(system_metrics_collector)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# Enable strict compiler flags if possible.
include(CheckCXXCompilerFlag)
set(FLAGS -pedantic -Wno-long-long -Wall -Wextra -Wcast-qual -Wformat -Wwrite-strings -Wcast-align
  -Wno-error=cast-align -Wmissing-declarations)
foreach(FLAG ${FLAGS})
  check_cxx_compiler_flag(${FLAG} R${FLAG})
  if(${R${FLAG}})
    set(WARNING_CXX_FLAGS "${WARNING_CXX_FLAGS} ${FLAG}")
  endif()
endforeach()

if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(libstatistics_collector REQUIRED)
find_package(message_filters REQUIRED)
find_package(rcl REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(statistics_msgs REQUIRED)
find_package(std_msgs REQUIRED)

rosidl_generate_interfaces(system_metrics_collector_test_msgs
  "test/msg/DummyMessage.msg"
  DEPENDENCIES std_msgs
  LIBRARY_NAME ${PROJECT_NAME}
)

include_directories(src)

add_library(${PROJECT_NAME} SHARED
  src/system_metrics_collector/linux_cpu_measurement_node.cpp
  src/system_metrics_collector/linux_memory_measurement_node.cpp
  src/system_metrics_collector/linux_process_cpu_measurement_node.cpp
  src/system_metrics_collector/linux_process_memory_measurement_node.cpp
  src/system_metrics_collector/periodic_measurement_node.cpp
  src/system_metrics_collector/proc_cpu_data.cpp
  src/system_metrics_collector/proc_pid_cpu_data.cpp
  src/system_metrics_collector/utilities.cpp
)
ament_target_dependencies(${PROJECT_NAME}
        message_filters
        rcl
        rclcpp
        rclcpp_components
        rclcpp_lifecycle
        rcpputils
        rcutils
        libstatistics_collector
        statistics_msgs)

rclcpp_components_register_nodes(${PROJECT_NAME}
  system_metrics_collector::LinuxProcessCpuMeasurementNode)
rclcpp_components_register_nodes(${PROJECT_NAME}
  system_metrics_collector::LinuxProcessMemoryMeasurementNode)
ament_export_libraries(system_metrics_collector)

add_executable(example_main src/system_metrics_collector/example_main.cpp)
target_link_libraries(example_main ${PROJECT_NAME})
ament_target_dependencies(example_main)

add_executable(linux_cpu_collector src/system_metrics_collector/linux_cpu_collector.cpp)
target_link_libraries(linux_cpu_collector ${PROJECT_NAME})
ament_target_dependencies(linux_cpu_collector)

add_executable(linux_memory_collector src/system_metrics_collector/linux_memory_collector.cpp)
target_link_libraries(linux_memory_collector ${PROJECT_NAME})
ament_target_dependencies(linux_memory_collector)

add_executable(dummy_talker src/topic_statistics_collector/dummy_talker.cpp)
target_link_libraries(dummy_talker system_metrics_collector)
ament_target_dependencies(dummy_talker)

add_executable(topic_statistics_node src/topic_statistics_collector/topic_statistics_node.cpp)
target_link_libraries(topic_statistics_node system_metrics_collector)
ament_target_dependencies(topic_statistics_node)


if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(class_loader REQUIRED)
  find_package(lifecycle_msgs REQUIRED)

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(test_metrics_message_publisher
    test/system_metrics_collector/test_metrics_message_publisher.cpp)
  target_link_libraries(test_metrics_message_publisher ${PROJECT_NAME})
  ament_target_dependencies(test_metrics_message_publisher rclcpp statistics_msgs)

  ament_add_gtest(test_linux_cpu_measurement_node
          test/system_metrics_collector/test_linux_cpu_measurement.cpp)
  target_link_libraries(test_linux_cpu_measurement_node ${PROJECT_NAME})
  ament_target_dependencies(test_linux_cpu_measurement_node rclcpp statistics_msgs)

  ament_add_gtest(test_linux_memory_measurement_node
          test/system_metrics_collector/test_linux_memory_measurement.cpp)
  target_link_libraries(test_linux_memory_measurement_node ${PROJECT_NAME})
  ament_target_dependencies(test_linux_memory_measurement_node lifecycle_msgs rclcpp statistics_msgs)

  ament_add_gtest(test_linux_process_cpu_measurement_node
          test/system_metrics_collector/test_linux_process_cpu_measurement_node.cpp)
  target_link_libraries(test_linux_process_cpu_measurement_node ${PROJECT_NAME})
  ament_target_dependencies(test_linux_process_cpu_measurement_node lifecycle_msgs rclcpp statistics_msgs)

  ament_add_gtest(test_linux_process_memory_measurement_node
          test/system_metrics_collector/test_linux_process_memory_measurement_node.cpp)
  target_link_libraries(test_linux_process_memory_measurement_node ${PROJECT_NAME})
  ament_target_dependencies(test_linux_process_memory_measurement_node lifecycle_msgs rclcpp statistics_msgs)

  ament_add_gtest(test_periodic_measurement_node
    test/system_metrics_collector/test_periodic_measurement_node.cpp)
  target_link_libraries(test_periodic_measurement_node ${PROJECT_NAME})
  ament_target_dependencies(test_periodic_measurement_node lifecycle_msgs rclcpp statistics_msgs)

  ament_add_gtest(test_composition
          test/system_metrics_collector/test_composition.cpp)
  ament_target_dependencies(test_composition class_loader rclcpp rclcpp_components)

  ament_add_gtest(test_utilities
          test/system_metrics_collector/test_utilities.cpp)
  target_link_libraries(test_utilities ${PROJECT_NAME})
  ament_target_dependencies(test_utilities rclcpp)

  ament_add_gtest(test_subscriber_topic_statistics
          test/topic_statistics_collector/test_subscriber_topic_statistics.cpp)
  target_link_libraries(test_subscriber_topic_statistics ${PROJECT_NAME})
  ament_target_dependencies(test_subscriber_topic_statistics rcl rclcpp)

  rosidl_target_interfaces(test_subscriber_topic_statistics system_metrics_collector_test_msgs "rosidl_typesupport_cpp")
endif()

# To enable use of dummy_message.hpp in executables
rosidl_target_interfaces(dummy_talker system_metrics_collector_test_msgs "rosidl_typesupport_cpp")
rosidl_target_interfaces(topic_statistics_node system_metrics_collector_test_msgs "rosidl_typesupport_cpp")

# Install launch files
install(DIRECTORY
  share/${PROJECT_NAME}/
  DESTINATION share/${PROJECT_NAME}/
)

# Install entry points
install(TARGETS
  example_main
  DESTINATION
  lib/${PROJECT_NAME}
)

install(TARGETS
  linux_cpu_collector
  DESTINATION
  lib/${PROJECT_NAME}
)

install(TARGETS
  linux_memory_collector
  DESTINATION
  lib/${PROJECT_NAME}
)

install(TARGETS
  dummy_talker
  DESTINATION
  lib/${PROJECT_NAME}
)

install(TARGETS
  topic_statistics_node
  DESTINATION
  lib/${PROJECT_NAME}
)

install(TARGETS
  ${PROJECT_NAME}
  DESTINATION
  lib
)

ament_export_dependencies(rosidl_default_runtime)
ament_export_libraries(${PROJECT_NAME})

ament_package()

=== debian/changelog ===
ros-foxy-system-metrics-collector (0.1.1-1focal) focal; urgency=high

  * Fix test_subscriber_topic_statistics being referenced out of scope causing colcon build with flag -DBUILD_TESTING=0 to fail. (#175 <https://github.com/ros-tooling/system_metrics_collector/issues/175>) (#176 <https://github.com/ros-tooling/system_metrics_collector/issues/176>)
  * Contributors: Jaison Titus

 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Wed, 02 Sep 2020 00:00:00 -0000

ros-foxy-system-metrics-collector (0.1.0-1focal) focal; urgency=high

  * Bump package version to 0.1.0 (#170 <https://github.com/ros-tooling/system_metrics_collector/issues/170>)
  * Allow topic statistics to subscribe to multiple topics (#143 <https://github.com/ros-tooling/system_metrics_collector/issues/143>)
  * Add topic statistics executable, launch file and e2e test (#125 <https://github.com/ros-tooling/system_metrics_collector/issues/125>)
  * Move metrics_statistics_msgs to rcl_interfaces (#135 <https://github.com/ros-tooling/system_metrics_collector/issues/135>)
  * Add DummyMessage talker node and launch file for it (#119 <https://github.com/ros-tooling/system_metrics_collector/issues/119>)
  * Fix test subscriber failures (#126 <https://github.com/ros-tooling/system_metrics_collector/issues/126>)
  * Move message generation function to libstatistics_collector (#122 <https://github.com/ros-tooling/system_metrics_collector/issues/122>)
  * Replace IMU messages with new dummy messages (#121 <https://github.com/ros-tooling/system_metrics_collector/issues/121>)
  * Add SubscriberTopicStatisticsNode and tests (#112 <https://github.com/ros-tooling/system_metrics_collector/issues/112>)
  * Create libstatistics_collector package (#117 <https://github.com/ros-tooling/system_metrics_collector/issues/117>)
  * Add statistic name and unit interfaces (#115 <https://github.com/ros-tooling/system_metrics_collector/issues/115>)
  * Use rcutils_time_point_value_t instead of rclcpp::Time (#113 <https://github.com/ros-tooling/system_metrics_collector/issues/113>)
  * Remove deprecated launch params (#109 <https://github.com/ros-tooling/system_metrics_collector/issues/109>)
  * Add message age collector class (#106 <https://github.com/ros-tooling/system_metrics_collector/issues/106>)
  * Refactor Linux process CPU measurement tests (#107 <https://github.com/ros-tooling/system_metrics_collector/issues/107>)
  * Dabonnie/fix cpu measurement test (#102 <https://github.com/ros-tooling/system_metrics_collector/issues/102>)
  * Move common test utilities (#101 <https://github.com/ros-tooling/system_metrics_collector/issues/101>)
  * Refactor Linux memory measurement tests (#100 <https://github.com/ros-tooling/system_metrics_collector/issues/100>)
  * Cleanup package.xml dependencies (#97 <https://github.com/ros-tooling/system_metrics_collector/issues/97>)
  * Add received message period measurement (#94 <https://github.com/ros-tooling/system_metrics_collector/issues/94>)
  * Fix relative #include paths (#95 <https://github.com/ros-tooling/system_metrics_collector/issues/95>)
  * Add test for collector state (#93 <https://github.com/ros-tooling/system_metrics_collector/issues/93>)
  * Move stateless method to free function (#92 <https://github.com/ros-tooling/system_metrics_collector/issues/92>)
  * Add e2e test workflow (#88 <https://github.com/ros-tooling/system_metrics_collector/issues/88>)
  * Fix uncrustify linting (#89 <https://github.com/ros-tooling/system_metrics_collector/issues/89>)
  * Add e2e test (#86 <https://github.com/ros-tooling/system_metrics_collector/issues/86>)
  * Add unit information to MetricsMessage (#85 <https://github.com/ros-tooling/system_metrics_collector/issues/85>)
  * Clarify that the main executable is an example (#84 <https://github.com/ros-tooling/system_metrics_collector/issues/84>)
  * Dabonnie/readme update (#82 <https://github.com/ros-tooling/system_metrics_collector/issues/82>)
  * Add example launch file (#81 <https://github.com/ros-tooling/system_metrics_collector/issues/81>)
  * Add configurable launch parameters (#80 <https://github.com/ros-tooling/system_metrics_collector/issues/80>)
  * Update README.md (#79 <https://github.com/ros-tooling/system_metrics_collector/issues/79>)
  * Dabonnie/add documentation (#77 <https://github.com/ros-tooling/system_metrics_collector/issues/77>)
  * Add unit test for composeability of nodes (#76 <https://github.com/ros-tooling/system_metrics_collector/issues/76>)
  * Make LinuxProcessCpuMeasurementNode and LinuxProcessMemoryMeasurementNode composeable (#67 <https://github.com/ros-tooling/system_metrics_collector/issues/67>)
  * Added some doc (#75 <https://github.com/ros-tooling/system_metrics_collector/issues/75>)
  * Refactor PeriodicMeasurementNode to inherit from LifecycleNode (#72 <https://github.com/ros-tooling/system_metrics_collector/issues/72>)
  * Use rclcpp::NodeOptions during node construction (#73 <https://github.com/ros-tooling/system_metrics_collector/issues/73>)
  * Add input argument checking to PeriodicMeasurementNode (#69 <https://github.com/ros-tooling/system_metrics_collector/issues/69>)
  * Add process CPU usage measurement node (#59 <https://github.com/ros-tooling/system_metrics_collector/issues/59>)
  * Fix linting issues (#54 <https://github.com/ros-tooling/system_metrics_collector/issues/54>)
  * Add launch file to launch system CPU and Memory collector nodes (#63 <https://github.com/ros-tooling/system_metrics_collector/issues/63>)
  * Replace test method with implementation (#62 <https://github.com/ros-tooling/system_metrics_collector/issues/62>)
  * Add process CPU usage measurement dependencies (#57 <https://github.com/ros-tooling/system_metrics_collector/issues/57>)
  * Follow variable naming conventions of ROS2 style guide (#56 <https://github.com/ros-tooling/system_metrics_collector/issues/56>)


=== debian/control ===
Source: ros-foxy-system-metrics-collector
Section: misc
Priority: optional
Maintainer: ROS Tooling Working Group <ros-tooling@googlegroups.com>
Build-Depends: debhelper (>= 9.0.0), python3-retrying, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-class-loader, ros-foxy-libstatistics-collector, ros-foxy-lifecycle-msgs, ros-foxy-message-filters, ros-foxy-rcl, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rclcpp-lifecycle, ros-foxy-rclpy, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-ros2launch, ros-foxy-ros2lifecycle, ros-foxy-ros2topic, ros-foxy-rosidl-default-generators, ros-foxy-statistics-msgs, ros-foxy-std-msgs, ros-foxy-ros-workspace, ros-foxy-rosidl-typesupport-connext-c, ros-foxy-rosidl-typesupport-connext-cpp, ros-foxy-rosidl-typesupport-fastrtps-c, ros-foxy-rosidl-typesupport-fastrtps-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-system-metrics-collector
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-demo-nodes-cpp, ros-foxy-libstatistics-collector, ros-foxy-message-filters, ros-foxy-rcl, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rclcpp-lifecycle, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rosidl-default-runtime, ros-foxy-statistics-msgs, ros-foxy-std-msgs, ros-foxy-ros-workspace
Description: Node and aggregation utilities to measure and publish system metrics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-system-metrics-collector//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
